package tc.oc.client.modules;

import net.minecraft.client.Minecraft;
import net.minecraft.src.GuiScreen;
import net.minecraft.src.KeyBinding;
import net.minecraft.src.NetClientHandler;
import net.minecraft.src.NetServerHandler;
import net.minecraft.src.Packet250CustomPayload;

public interface IModule {

    /**
     * Gets a readable name of the module
     * 
     * @return String name
     */
    public String getName();

    /**
     * Gets the module version number based
     * 
     * @return String version
     */
    public String getVersion();

    /**
     * Set the enable/disable state of the module
     * 
     * @param state boolean enable=true disable=false
     */
    public void setState(boolean state);

    /**
     * Returns the boolean value of enable or disable
     * 
     * @return boolean enable=true disable=false
     */
    public boolean getState();

}
