package tc.oc.client.modules.gui;

import java.util.Iterator;

import net.minecraft.client.Minecraft;
import net.minecraft.src.GuiButton;
import net.minecraft.src.GuiGameOver;
import net.minecraft.src.GuiScreen;
import net.minecraft.src.StatCollector;

import tc.oc.client.UndercastClient;
import tc.oc.client.modules.IGuiTick;
import tc.oc.client.modules.IModule;

public class GUIDeathMenu extends GuiGameOver implements IModule,IGuiTick {
    private UndercastClient client;
    private String name = "Death Menu Gui";
    private String version = "0.1.2";
    private boolean state = false;

    public GUIDeathMenu(UndercastClient client) {
        this.client = client;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public String getVersion() {
        return version;
    }

    @Override
    public void setState(boolean state) {
        this.state = state;
    }

    @Override
    public boolean getState() {
        return state;
    }

    @Override
    public boolean onTickInGUI(float tick, Minecraft mc, GuiScreen screen) {
        if(screen instanceof GuiGameOver && !(screen instanceof GUIDeathMenu)){
            mc.displayGuiScreen(this);
            return true;
        }
        return false;
    }

    /**
     * Overrides the GuiGameOver initGui;
     */
    @Override
    public void initGui() {
        this.buttonList.clear();

        // add respawn
        this.buttonList.add(new GuiButton(1, this.width / 2 - 100, this.height / 4 + 72, StatCollector.translateToLocal("deathScreen.respawn")));
        // add title menu
        this.buttonList.add(new GuiButton(2, this.width / 2 - 100, this.height / 4 + 96, StatCollector.translateToLocal("deathScreen.titleScreen")));

        ((GuiButton) this.buttonList.get(1)).enabled = false;
    }
}
