package tc.oc.client.modules.gui;

import net.minecraft.client.Minecraft;
import net.minecraft.src.GuiButton;
import net.minecraft.src.GuiConnecting;
import net.minecraft.src.GuiMainMenu;
import net.minecraft.src.GuiScreen;
import net.minecraft.src.ServerData;
import net.minecraft.src.StringTranslate;
import tc.oc.client.UndercastClient;
import tc.oc.client.data.Strings;
import tc.oc.client.modules.IGuiTick;
import tc.oc.client.modules.IModule;

public class GUIMainMenu extends GuiMainMenu implements IModule,IGuiTick {
    private UndercastClient client;
    private String name = "Main Menu Gui";
    private String version = "0.1.3";
    private boolean state = false;

    public GUIMainMenu(UndercastClient client) {
        this.client = client;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public String getVersion() {
        return version;
    }

    @Override
    public void setState(boolean state) {
        this.state = state;
    }

    @Override
    public boolean getState() {
        return state;
    }

    @Override
    public boolean onTickInGUI(float tick, Minecraft mc, GuiScreen screen) {
        if(screen instanceof GuiMainMenu && !(screen instanceof GUIMainMenu)){
            mc.displayGuiScreen(this);
            return true;
        }
        return false;
    }

    /**
     * Overrides the GuiMainMenu initGui; Calls super constructor to construct all buttons and init the gui; Edits the current button list, new width, and add new button.
     */
    @Override
    public void initGui() {
        // Call the super method
        super.initGui();

        // Get all the old values for the menu
        StringTranslate stringtranslate = StringTranslate.getInstance();
        GuiButton oldMulti = ((GuiButton) this.buttonList.get(1));
        int x = oldMulti.xPosition;
        int y = oldMulti.yPosition;

        // Reset the multiplayer button to new width; Add new Project Ares Button
        this.buttonList.set(1, new GuiButton(2, x, y, 99, 20, stringtranslate.translateKey("menu.multiplayer")));
        this.buttonList.add(new GuiButton(-10, x + 102, y, 99, 20, Strings.LOGIN_BUTTON));
    }

    /**
     * When button on menu is pressed this is called; Calls the super first then sees if it was a custom button
     */
    @Override
    public void actionPerformed(GuiButton event) {
        // If the LOGIN_BUTTON is pressed then open to the server/server ip
        if(event.id == -10){
            ServerData joinServer = new ServerData(Strings.SERVER_NAME, Strings.SERVER_IP);
            this.mc.displayGuiScreen(new GuiConnecting(this, this.mc, joinServer));
        }
        // Go perform default actions
        else{
            super.actionPerformed(event);
        }
    }
}
