package tc.oc.client.modules.notifier;

import java.awt.image.BufferedImage;
import java.net.URL;
import java.net.URLConnection;

import javax.imageio.ImageIO;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

import tc.oc.client.util.UCLogger;

import net.minecraft.client.Minecraft;
import net.minecraft.src.Achievement;
import net.minecraft.src.GuiAchievement;
import net.minecraft.src.RenderHelper;
import net.minecraft.src.RenderItem;
import net.minecraft.src.ScaledResolution;
import net.minecraft.src.StatCollector;

public class FakeAchievement extends GuiAchievement {

    private Minecraft theGame;
    private int achievementWindowWidth;

    private int achievementWindowHeight;
    private String achievementGetLocalText;
    private String achievementStatName;

    private Achievement theAchievement;
    private long achievementTime;

    private RenderItem itemRender;
    private boolean haveAchiement;

    // Variables
    private ImageLoader imgLoader;
    public static BufferedImage imageBuffer = null;
    String line_1 = "";
    String line_2 = "";

    public FakeAchievement(Minecraft par1Minecraft, String line_1, String line_2) {
        super(par1Minecraft);
        this.theGame = par1Minecraft;
        this.itemRender = new RenderItem();
        // Init the image loader to be load the player head in.
        this.imgLoader = new ImageLoader(par1Minecraft.texturePackList, par1Minecraft.gameSettings);
        this.line_1 = line_1;
        this.line_2 = line_2;
    }

    /** A threaded download of a head from minotar */
    public void startImageDownload(String profile) {
        // start image download
        try{
            URLConnection downloadImage = new URL("https://minotar.net/helm/" + profile + "/16.png").openConnection();
            downloadImage.addRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0; H010818)");
            imageBuffer = ((BufferedImage) ImageIO.read(downloadImage.getInputStream()));
        }catch(Exception e){
            //UCLogger.logSevereException("FakeAchievement error", e);
            UCLogger.logInfo("Could not download "+profile+" helm picture");
        }
    }

    /** Queue a taken achievement to be displayed. */
    public void queueTakenAchievement(Achievement par1Achievement) {
        this.achievementGetLocalText = StatCollector.translateToLocal("achievement.get");
        this.achievementStatName = StatCollector.translateToLocal(par1Achievement.getName());
        this.achievementTime = Minecraft.getSystemTime();
        this.theAchievement = par1Achievement;
        this.haveAchiement = false;
    }

    /** Queue a information about a achievement to be displayed. */
    public void queueAchievementInformation(Achievement par1Achievement) {
        this.achievementGetLocalText = StatCollector.translateToLocal(par1Achievement.getName());
        this.achievementStatName = par1Achievement.getDescription();
        this.achievementTime = Minecraft.getSystemTime() - 2500L;
        this.theAchievement = par1Achievement;
        this.haveAchiement = true;
    }

    /** Update the display of the achievement window to match the game window. */
    private void updateAchievementWindowScale() {
        GL11.glViewport(0, 0, this.theGame.displayWidth, this.theGame.displayHeight);
        GL11.glMatrixMode(GL11.GL_PROJECTION);
        GL11.glLoadIdentity();
        GL11.glMatrixMode(GL11.GL_MODELVIEW);
        GL11.glLoadIdentity();
        this.achievementWindowWidth = this.theGame.displayWidth;
        this.achievementWindowHeight = this.theGame.displayHeight;
        ScaledResolution var1 = new ScaledResolution(this.theGame.gameSettings, this.theGame.displayWidth, this.theGame.displayHeight);
        this.achievementWindowWidth = var1.getScaledWidth();
        this.achievementWindowHeight = var1.getScaledHeight();
        GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
        GL11.glMatrixMode(GL11.GL_PROJECTION);
        GL11.glLoadIdentity();
        GL11.glOrtho(0.0D, (double) this.achievementWindowWidth, (double) this.achievementWindowHeight, 0.0D, 1000.0D, 3000.0D);
        GL11.glMatrixMode(GL11.GL_MODELVIEW);
        GL11.glLoadIdentity();
        GL11.glTranslatef(0.0F, 0.0F, -2000.0F);
    }

    /** Updates the small achievement tooltip window, showing a queued achievement if is needed. */
    @Override
    public void updateAchievementWindow() {
        if(this.theAchievement != null && this.achievementTime != 0L){
            double d0 = (double) (Minecraft.getSystemTime() - this.achievementTime) / 3000.0D;
            if(!this.haveAchiement && (d0 < 0.0D || d0 > 1.0D)){
                this.achievementTime = 0L;
            }else{
                this.updateAchievementWindowScale();
                GL11.glDisable(GL11.GL_DEPTH_TEST);
                GL11.glDepthMask(false);
                double d1 = d0 * 2.0D;
                if(d1 > 1.0D){
                    d1 = 2.0D - d1;
                }
                d1 *= 4.0D;
                d1 = 1.0D - d1;
                if(d1 < 0.0D){
                    d1 = 0.0D;
                }
                d1 *= d1;
                d1 *= d1;
                int i = this.achievementWindowWidth - 160;
                int j = 0 - (int) (d1 * 36.0D);
                GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
                GL11.glEnable(GL11.GL_TEXTURE_2D);
                this.theGame.renderEngine.bindTexture("/achievement/bg.png");
                GL11.glDisable(GL11.GL_LIGHTING);
                this.drawTexturedModalRect(i, j, 96, 202, 160, 32);

                // Draw the two text lines on the gui
                this.theGame.fontRenderer.drawString(line_1, i + 30, j + 7, 16777215);
                this.theGame.fontRenderer.drawString(line_2, i + 30, j + 18, 16777215);

                RenderHelper.enableGUIStandardItemLighting();
                GL11.glDisable(GL11.GL_LIGHTING);
                GL11.glEnable(GL12.GL_RESCALE_NORMAL);
                GL11.glEnable(GL11.GL_COLOR_MATERIAL);
                GL11.glEnable(GL11.GL_LIGHTING);

                // Loading the buffer as a readable image and set it as GL11 texture
                // 20 is a unique id, and both 16 are for the size of the image
                try{
                    this.imgLoader.setupTexture(imageBuffer, 20, 16, 16);
                }catch(Exception e){
                    UCLogger.logSevereException("FakeAchievement error", e);
                }

                // New GL11 matrix to not affect other part of the gui
                GL11.glPushMatrix();
                // White light on the image
                GL11.glColor4f(1, 1, 1, 1);
                // Resizing the image (divided by 16 in the diagonal)
                GL11.glScalef(1F / 16F, 1F / 16F, 1F);
                // Translating the image in the gui
                GL11.glTranslatef((i + 8) * 16F, (j + 8) * 16F, 0);
                // Drawing the image
                this.drawTexturedModalRect(0, 0, 0, 0, 256, 256);
                GL11.glPopMatrix();
                GL11.glDisable(GL11.GL_LIGHTING);
                GL11.glDepthMask(true);
                GL11.glEnable(GL11.GL_DEPTH_TEST);
            }
        }
    }

}
