package tc.oc.client.modules.notifier;

import net.minecraft.client.Minecraft;
import net.minecraft.src.Achievement;
import net.minecraft.src.EntityPlayer;
import net.minecraft.src.Item;
import net.minecraft.src.ModLoader;
import net.minecraft.src.StringUtils;
import tc.oc.client.UndercastClient;
import tc.oc.client.modules.IClientChat;
import tc.oc.client.modules.IModule;
import tc.oc.client.util.UCLogger;

public class GUINotifier implements IModule,IClientChat {
    private UndercastClient client;
    private String name = "Notifier Gui";
    private String version = "0.0.4";
    private boolean state = false;

    public GUINotifier(UndercastClient client) {
        this.client = client;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public String getVersion() {
        return version;
    }

    @Override
    public void setState(boolean state) {
        this.state = state;
    }

    @Override
    public boolean getState() {
        return state;
    }

    @Override
    public void clientChat(String var1) {
        // Local Data
        String username = ModLoader.getMinecraftInstance().thePlayer.username;
        EntityPlayer player = ModLoader.getMinecraftInstance().thePlayer;
        String message = StringUtils.stripControlCodes(var1);
        // If you die from someone
        if(message.startsWith(username) && !message.toLowerCase().endsWith(" team") && (message.contains(" by ") || message.contains(" took ") || message.contains("fury of"))){
            String profile = message.substring(message.indexOf("by") + 3, message.lastIndexOf("'s") == -1 ? message.length() : message.lastIndexOf("'s"));
            String line_1 = message.substring(message.indexOf("by") + 3, message.lastIndexOf("'s") == -1 ? message.length() : message.lastIndexOf("'s"));
            String line_2 = "\u00A74+1 Death";
            this.displayNotification(profile, line_1, line_2);
        }
        // If you kill a person
        else if(message.contains("by " + username) || message.contains("took " + username) || message.contains("fury of " + username)){
            String profile = message.substring(0, message.indexOf(" "));
            String line_1 = message.substring(0, message.indexOf(" "));
            String line_2 = "\u00A72+1 Kill";
            this.displayNotification(profile, line_1, line_2);
        }
        // When you die; but nobody killed you.
        else if(message.startsWith(username) && !message.toLowerCase().endsWith(" team") && !message.toLowerCase().contains("joined the game")){
            String profile = username;
            String line_1 = username;
            String line_2 = "\u00A74+1 Death";
            this.displayNotification(profile, line_1, line_2);
        }

    }

    private void displayNotification(final String profile, final String line_1, final String line_2) {
        // Create notification
        final FakeAchievement notification = new FakeAchievement(ModLoader.getMinecraftInstance(), line_1, line_2);
        // Download image thread
        Runnable r1 = new Runnable() {
            public void run() {
                try{
                    notification.startImageDownload(profile);
                }catch(Exception e){
                    UCLogger.logSevereException("GUINotifier error", e);
                }
                
            }
        };
        // Display gui after 1 sec delay
        Runnable r2 = new Runnable() {
            public void run() {
                try{
                    // Sleep to give time for download
                    Thread.sleep(1000L);
                    // Create achievement
                    Achievement custom = (new Achievement(27, "custom", 1, 4, Item.ingotIron, (Achievement) null));
                    Minecraft.getMinecraft().guiAchievement = notification;
                    notification.queueTakenAchievement(custom);
                }catch(Exception e){
                    UCLogger.logSevereException("GUINotifier error", e);
                }
            }
        };
        Thread thread1 = new Thread(r1);
        Thread thread2 = new Thread(r2);
        thread1.start();
        thread2.start();
    }
}
