package tc.oc.client.modules.stats;

import tc.oc.client.data.Strings;
import tc.oc.client.data.Teams;
import net.minecraft.client.Minecraft;
import net.minecraft.src.EntityClientPlayerMP;
import net.minecraft.src.StringUtils;

public class StatChat {

    public static void clientChat(String var1, StatData data) {
        // Local Data
        String message = StringUtils.stripControlCodes(var1);
        EntityClientPlayerMP player = Minecraft.getMinecraft().thePlayer;
        String username = player.username;

        // Update map string
        if(message.contains("Now playing")){
            message = message.replace("Now playing ", "");
            data.map_current = message.split(" by ")[0];
        }
        // If you die.
        else if(message.startsWith(username) && !message.toLowerCase().endsWith(" team")){
            // If you die from someone.
            if(message.contains(" by ") || message.contains(" took ")){
                data.death_player++;
            }
            data.death_total++;
            data.killstreak_current = 0;
        }
        // When you kill a person
        else if(message.contains("by " + username) || message.contains("took " + username) || message.contains("fury of " + username)){
            data.kills_total++;
            data.killstreak_current++;
        }
        // When you join an match update your info/reset it.
        else if(message.contains("You joined the")){
            try{
                data.resetStatData();
                Teams temp = Teams.valueOf(message.replace("You joined the ", "").replace(" Team", "").replace(" team", ""));
                data.display_team = "\u00A7" + temp.teamColor() + temp.toString();
            }catch(Exception e){
                data.resetStatData();
                data.display_team = "\u00A7" + Teams.None.teamColor() + Teams.None.toString();
            }
        }
        // When a map is done, display all the stats
        else if(!message.startsWith("<") && message.toLowerCase().contains("cycling to") && message.contains("1 second")){
            player.addChatMessage("\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-");
            player.addChatMessage("Final Stats:");
            player.addChatMessage("\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-\u00A7m-");
            player.addChatMessage("Team: " + data.display_team);
            player.addChatMessage("K/D: " + Strings.COLORCODE_KD + data.display_kd);
            player.addChatMessage("K/K: " + Strings.COLORCODE_KK + data.display_kk);
            player.addChatMessage("Kills: " + Strings.COLORCODE_KILLS + data.kills_total);
            player.addChatMessage("Deaths: " + Strings.COLORCODE_DEATHS + data.death_total);
            player.addChatMessage("Streak: " + Strings.COLORCODE_KILLSTREAK + data.killstreak_current + "/" + data.killstreak_max);
            data.resetStatData();
        }
        // Simple server detection
        else if(message.contains("You are currently on ")){
            data.server = message.replace("You are currently on ", "");
        }else if(message.contains("Teleporting you to ")){
            // If going to a new server reset player data.
            data.resetStatData();
            data.server = message.replace("Teleporting you to ", "");
        }else if(message.equals("                    ")){
            Minecraft.getMinecraft().thePlayer.sendChatMessage("/server");
        }
    }
}
