package tc.oc.client.modules.stats;

import java.text.DecimalFormat;
import java.util.Calendar;

import org.lwjgl.input.Keyboard;

import net.minecraft.client.Minecraft;
import net.minecraft.src.KeyBinding;
import tc.oc.client.UndercastClient;
import tc.oc.client.data.Strings;
import tc.oc.client.data.Teams;
import tc.oc.client.util.UCLogger;

public class StatData {
    // Variables
    private UndercastClient client;

    // Data
    protected int death_player = 0;
    protected int death_total = 0;
    protected int kills_total = 0;
    protected int killstreak_current = 0;
    protected int killstreak_max = 0;

    protected long servertime_login = 0;
    protected long servertime_total = 0;

    protected String fps = "0";
    protected String server = "Unknown";
    protected String map_current = "Unknown";
    protected String map_next = "Unknown";
    protected String display_servertime = "0h:0m";
    protected String display_team = "\u00A7" + Teams.Observers.teamColor() + Teams.Observers.toString();
    protected String display_kd = "0.0";
    protected String display_kk = "0.0";

    protected boolean fullbright_toggle = false;

    public float brightLevel = (float) 20.0D;
    public float defaultLevel = (float) 0.0D;

    public static enum MatchState{
        Starting,Started,Finished,Waiting,Lobby,Unknown
    };

    public static enum ServerType{
        Lobby,Blitz,ProjectAres,Unknown
    };

    public StatData(UndercastClient client) {
        this.client = client;
    }

    /**
     * Resets all MATCH related data
     */
    public void resetStatData() {
        death_total = 0;
        death_player = 0;
        kills_total = 0;
        killstreak_current = 0;
        killstreak_max = 0;

        display_team = "\u00A7" + Teams.Observers.teamColor() + Teams.Observers.toString();
        display_kd = "0.0";
        display_kk = "0.0";
    }

    /**
     * Updates all variables and data in this class
     */
    public void updateData() {
        // Fps update
        this.fps = Minecraft.getMinecraft().debug.split(",")[0];

        // Playing time update
        long tempElapsed = System.currentTimeMillis() - servertime_login;
        this.servertime_total += tempElapsed;
        this.servertime_login = System.currentTimeMillis();
        this.display_servertime = (int) (servertime_total / (60 * 60 * 1000F)) + "h:" + (int) (servertime_total / (60 * 1000F)) + "m";

        // Update stat strings
        if(killstreak_max < killstreak_current)
            killstreak_max = killstreak_current;
        // Update KD
        if(kills_total == death_total && kills_total == 0){
            display_kd = "0.0";
        }else if(kills_total > 0 && death_total == 0){
            display_kd = kills_total + ".0";
        }else if(kills_total == death_total && kills_total > 0){
            display_kd = "1.0";
        }else{
            DecimalFormat twoDForm = new DecimalFormat("#.##");
            display_kd = Double.valueOf(twoDForm.format(kills_total / death_total)) + "";
        }
        // Update KK
        if(kills_total == death_player && kills_total == 0){
            display_kk = "0.0";
        }else if(kills_total > 0 && death_player == 0){
            display_kk = kills_total + ".0";
        }else if(kills_total == death_player && death_player > 0){
            display_kk = "1.0";
        }else{
            DecimalFormat twoDForm = new DecimalFormat("#.##");
            display_kd = Double.valueOf(twoDForm.format(kills_total / death_player)) + "";
        }
    }

}
